-- Menus for Sunflower's Garden
-- some cvars are found in their respective scripts
-- others are here because it's either vanilla, not reusable, or just can't be bothered to move the definition to the script

local function add(t) table.insert(CONFIG_Queue, t) end

--- HUD ---
add{name = "showitemtimers", possiblevalue = CV_YesNo,
	config_menu = "HUD", displayname = "Item timers",
	description = "Show timers for all active items and boosts at the bottom of the screen."}

add{name = "lb_gui", possiblevalue = { Off = 0, Splits = 1, On = 2 },
	config_menu = "HUD", displayname = "Leaderboard",
	description = "Enable leaderboards for record attack."}

add{name = "lb_smallhud", possiblevalue = CV_OnOff,
	config_menu = "HUD", displayname = "Small leaderboard",
	description = "Reduce leaderboard HUD size."}

add{name = "as_trickgauge", possiblevalue = CV_OnOff,
	config_menu = "HUD", displayname = "Trick gauge",
	description = "If Acrobasics is enabled, display the remaining time of your boost."}


--- VANILLA ---
add{name = "cam_height",
	config_menu = "Vanilla", displayname = "Camera height", config_multi = { "cam2_height", "cam3_height", "cam4_height" },
	description = "Height of camera, in fracunits."}

add{name = "cam_dist",
	config_menu = "Vanilla", displayname = "Camera distance", config_multi = { "cam2_dist", "cam3_dist", "cam4_dist" },
	description = "Horizontal camera distance, in fracunits."}

add{name = "cam_speed",
	config_menu = "Vanilla", displayname = "Camera speed", config_multi = { "cam2_speed", "cam3_speed", "cam4_speed" },
	description = "How quickly the camera moves vertically and rotates."}

add{name = "cam_rotate",
	config_menu = "Vanilla", displayname = "Camera rotation", config_multi = { "cam2_rotate", "cam3_rotate", "cam4_rotate" },
	description = "Rotation offset, in degrees."}

add{name = "cam_still", possiblevalue = CV_OnOff,
	config_menu = "Vanilla", displayname = "Still camera", config_multi = { "cam2_still", "cam3_still", "cam4_still" },
	description = "Don't rotate the camera at all. Have fun racing with this on."}

add{name = "flipcam", possiblevalue = CV_OnOff,
	config_menu = "Vanilla", displayname = "Flip camera",
	description = "Flip the camera in reverse gravity.", config_multi = { "flipcam2", "flipcam3", "flipcam4" }}

add{name = "gr_fovchange", possiblevalue = CV_OnOff,
	config_menu = "Vanilla", displayname = "FOV change",
	description = "OpenGL only: Increase your FOV as you speed up."}

add{name = "pingmeasurement", possiblevalue = { Frames = 0, Milliseconds = 1 },
	config_menu = "Vanilla", displayname = "Ping measurement",
	description = "Display input delay in tics or milliseconds."}

add{name = "con_height",
	config_menu = "Vanilla", displayname = "Console lines",
	description = "Number of lines to display in the console."}

add{name = "con_hudlines",
	config_menu = "Vanilla", displayname = "Console HUD lines",
	description = "Number of lines to display in the HUD, minus one."}

add{name = "con_hudtime",
	config_menu = "Vanilla", displayname = "Console HUD time",
	description = "How many seconds each HUD line is displayed for."}

add{name = "con_speed",
	config_menu = "Vanilla", displayname = "Console speed",
	description = "How quickly the console opens or closes. Zero disables the animation."}

add{name = "con_backpic", possiblevalue = { translucent = 0, picture = 1 },
	config_menu = "Vanilla", displayname = "Console backpic",
	description = "Cover your screen with the beautiful Kart Krew logo every time you open the console."}


--- HITFEED ---
add{name = "hitfeed", possiblevalue = CV_OnOff,
	config_menu = "Hitfeed", displayname = "Enabled",
	description = "Enable Hitfeed."}

add{name = "hf_displaymode", possiblevalue = { Names = 1, Icons = 2, Both = 3 },
	config_menu = "Hitfeed", displayname = "Display mode",
	description = "Display names, icons, or both."}

add{name = "hf_charlimit",
	config_menu = "Hitfeed", displayname = "Max name length",
	description = "Display this many characters of a player's name."}

add{name = "hf_messagelimit",
	config_menu = "Hitfeed", displayname = "Message limit",
	description = "Max number of hitmessages to display."}

add{name = "hf_backdrop", possiblevalue = CV_OnOff,
	config_menu = "Hitfeed", displayname = "Background",
	description = "Enable backgrounds for hitmessages."}

add{name = "hf_highlightcolor", possiblevalue = SG_CVSkinColors,
	config_menu = "Hitfeed", displayname = "Highlight color",
	description = "Use this color to highlight relevant hitmessages."}

add{name = "hf_colorednames", possiblevalue = CV_OnOff,
	config_menu = "Hitfeed", displayname = "Name colors",
	description = "Show player colors in hitmessages."}


--- MINI RANKINGS ---
add{name = "mrp_forcedisplay", possiblevalue = { On = 1, None = 0, Off = -1 },
	config_menu = "Mini Rankings", displayname = "Force enable",
	description = "Forcibly enable/disable Mink Rankings Plus."}

add{name = "mrp_showitemslocal", possiblevalue = CV_YesNo,
	config_menu = "Mini Rankings", displayname = "Item spy", config_global = "mrp_showitems",
	description = "Display items next to ranking icons."}

add{name = "mrp_showitemswhenspectating", possiblevalue = CV_YesNo,
	config_menu = "Mini Rankings", displayname = "Spectator item spy",
	description = "Always show other players' items when spectating."}

add{name = "mrp_shrinkgrow", possiblevalue = CV_YesNo,
	config_menu = "Mini Rankings", displayname = "Show Grow/Shrink",
	description = "Scale icons if Grow or Shrink is used."}

add{name = "mrp_spinoutshake", possiblevalue = CV_YesNo,
	config_menu = "Mini Rankings", displayname = "Show spinout",
	description = "Shake a player's icon if they spin out."}

add{name = "mrp_showflashtics", possiblevalue = CV_YesNo,
	config_menu = "Mini Rankings", displayname = "Show flashing",
	description = "Show flash tics on player icons."}

add{name = "mrp_showinvis", possiblevalue = CV_YesNo,
	config_menu = "Mini Rankings", displayname = "Hide if invisible",
	description = "If a player uses Hyudoro, make their icon transparent."}

add{name = "mrp_showhorns", possiblevalue = CV_YesNo,
	config_menu = "Mini Rankings", displayname = "Show horns",
	description = "Display Hornmod horns next to player icons."}

add{name = "mrp_hpmodshowhplocal", possiblevalue = CV_YesNo,
	config_menu = "Mini Rankings", displayname = "Show HP", config_global = "mrp_hpmodshowhp",
	description = "Display HPMOD HP on player icons."}

add{name = "mrp_showcombi", possiblevalue = CV_YesNo,
	config_menu = "Mini Rankings", displayname = "Show combi",
	description = "Group icons together when Combi Ring is enabled."}

add{name = "mrp_friendmodshowteams", possiblevalue = CV_YesNo,
	config_menu = "Mini Rankings", displayname = "Show teams",
	description = "Highlight icons with the player's Friendmod team color."}

add{name = "hud_mrp_xoffset",
	config_menu = "Mini Rankings", displayname = "Mini Ranking offset", config_hudmove = "hud_mrp_yoffset",
	description = "Change offsets for the mini ranking."}


--- OTHER ---
add{name = "dub_enabled", possiblevalue = CV_OnOff,
	config_menu = "Other", displayname = "Character dubs",
	description = "Enable alternate voices for some characters. (use console command \"dub\" for more info)"}

add{name = "powermusic", possiblevalue = CV_OnOff,
	config_menu = "Other", displayname = "Power music",
	description = "Play special music when using Grow or Invincibility."}

add{name = "randommusic", possiblevalue = CV_OnOff,
	config_menu = "Other", displayname = "Random music",
	description = "Randomize music for each map."}

add{name = "au_spectate_sink", possiblevalue = CV_OnOff,
	config_menu = "Other", displayname = "Specate Sink holder",
	description = "Automatically spectate anyone who rolls a Kitchen Sink."}

add{name = "showgrapletip", possiblevalue = CV_OnOff,
	config_menu = "Other", displayname = "Graple tip",
	description = "Print a tip in chat when Grapling is enabled."}

add{name = "cw_density",
	config_menu = "Other", displayname = "Custom weather density",
	description = "Set the density of custom weather on some maps." } -- mauromania, RA extended

add{name = "ss_shutup", possiblevalue = CV_OnOff,
	config_menu = "Other", displayname = "Silence announcer",
	description = "Tell the Sloppy Sludge announcer to shut up."}

add{name = "slipstream_colorized", possiblevalue = CV_OnOff,
	config_menu = "Other", displayname = "Slipstream color",
	description = "Colorize Slipstream lines."}

add{name = "slipstream_reminder", possiblevalue = CV_OnOff,
	config_menu = "Other", displayname = "Slipstream reminder",
	description = "Print a chat message at the start of every race if Slipstream is enabled."}

add{name = "horn_ignorecountdown_local", possiblevalue = CV_OnOff,
	config_menu = "Other", displayname = "Horns in countdown", config_global = "horn_ignorecountdown",
	description = "Hear other players' Hornmod horns during the countdown."}


--- HOSTMOD ---
add{name = "powersound", possiblevalue = CV_OnOff,
	config_menu = "Hostmod", displayname = "Power item ending",
	description = "Play a sound when a power item is about to end."}

add{name = "powerflash", possiblevalue = CV_OnOff,
	config_menu = "Hostmod", displayname = "Grow ending flash",
	description = "Flash when Grow is about to end."}


--- MAP RECORDS ---
add{name = "mpr_record_show", possiblevalue = CV_OnOff,
	config_menu = "Map Records", displayname = "Show records",
	description = "Display map records."}

add{name = "mpr_newrecord_show", possiblevalue = CV_OnOff,
	config_menu = "Map Records", displayname = "Show new records",
	description = "Announce new records when the race ends."}

add{name = "mpr_record_xoffset",
	config_menu = "Map Records", displayname = "HUD offset", config_hudmove = "mpr_record_yoffset",
	description = "Change HUD offsets for map records."}


--- DYNMUSIC ---
add{name = "victorythemes", possiblevalue = CV_OnOff,
	config_menu = "Dynmusic", displayname = "Victory themes",
	description = "Play custom music when you win a race."}

add{name = "encoremusic", possiblevalue = CV_OnOff,
	config_menu = "Dynmusic", displayname = "Encore music",
	description = "Play custom music when Encore is enabled."}

add{name = "mymusic", possiblevalue = CV_OnOff,
	config_menu = "Dynmusic", displayname = "My music",
	description = "Play your own choice of music."}

add{name = "megamixthemes", possiblevalue = CV_OnOff,
	config_menu = "Dynmusic", displayname = "Megamix themes",
	description = "Play custom music while using power items."}

add{name = "finallapmusic", possiblevalue = CV_OnOff,
	config_menu = "Dynmusic", displayname = "Final lap music",
	description = "Play custom music on the final lap."}

add{name = "spbmusic", possiblevalue = CV_OnOff,
	config_menu = "Dynmusic", displayname = "SPB music",
	description = "Play custom music while being chased by an SPB."}

add{name = "spbmapoverride", possiblevalue = CV_OnOff,
	config_menu = "Dynmusic", displayname = "SPB map override",
	description = "Override map-specific SPB music, if any."}

add{name = "spbrandomize", possiblevalue = CV_OnOff,
	config_menu = "Dynmusic", displayname = "SPB randomize",
	description = "Randomize SPB music."}

add{name = "spbcredit", possiblevalue = { Never = 0, Once = 1, Always = 2 },
	config_menu = "Dynmusic", displayname = "SPB credit",
	description = "When to show credit for SPB music."}


--- ELIMINATION ---
add{name = "elim_announcements", possiblevalue = CV_OnOff,
	config_menu = "Elimination", displayname = "Announcements",
	description = "Announce the names of dead players."}

add{name = "elim_flashintensity",
	config_menu = "Elimination", displayname = "Flash intensity",
	description = "Set the intensity of the red screen flash."}

add{name = "elim_overbounce",
	config_menu = "Elimination", displayname = "Overtime scale",
	description = "How much to scale up the timer during overtime, for dramatic effect."}
